Unit QSF6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS11_p;

procedure QSF6R(var RINT1 :Real; var RINT2 :Real; var A :Real;
                var B :Real; F :Func_F1; RO :Real; FI :Real; var E :Real;
                L1 :Integer; L2 :Integer; var XA :Real);

implementation

procedure QSF6R(var RINT1 :Real; var RINT2 :Real; var A :Real;
                var B :Real; F :Func_F1; RO :Real; FI :Real; var E :Real;
                L1 :Integer; L2 :Integer; var XA :Real);
var
U,V,X,BD,IL :Integer;
S,INT1,INT2,INT3,INT4,I,J,J1,K,L,M,C,D,G,BS,Q1,BA,W,J2,BM,H,BQ,BO,P,
   BN,BP,E1,BF,BT,BU,BL,BV,BX,BR,BG,Z1,Z2,BH,E2,Q,R,E3,BB,BC,EPS,
   T :Real;
NI,NIS,Y,Z :Boolean;
BE :Array [0..4] of Real;
BI :Array [0..4] of Real;
BJ :Array [0..4] of Real;
BK :Array [0..4] of Real;
BW :Array [0..6] of Real;
const
SYS051 :Real = 1.192093E-7;
HMIN :Real = 1.0E-4;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50,_51,_52;
begin
NIS := ( A  > B );
if (  not ( (NIS) ) ) 
 then goto _1;
BA := A;
A := B;
B := BA;
Y := True;
_1:
V := 2;
EPS := Abs(E);
K := B;
X := 1;
C := 0;
D := 0;
G := 0;
I := 0;
if ( B-100 ) < 0
 then goto _4
 else if ( B-100 ) > 0
       then goto _2
       else goto _2;
_2:
if ( A+100 ) < 0
 then goto _3
 else if ( A+100 ) > 0
       then goto _29
       else goto _3;
_3:
Y := False;
X := -1;
E := E/2;
B := A;
A := 0.0;
goto _29;
_4:
X := -1;
Q1 := A;
A := B;
B := Q1;
goto _29;
_5:
NI := ( A  > B );
if (  not ( (NI) ) ) 
 then goto _6;
BA := A;
A := B;
B := BA;
_6:
W := B-A;
if (  not ( (W  = 0) ) ) 
 then goto _7;
J1 := 0;
J2 := 0;
E1 := 0;
case U of
 1: goto _33;
 2: goto _38;
end;
_7:
Z2 := E/W;
H := 1;
Z1 := EPS/W;
P := 0;
E1 := 0;
J1 := 0;
J2 := 0;
_8:
BM := H/2.0;
BL := W*BM;
BQ := BL*RO;
BO := H*0.25;
for BD:=1 to 5 do
 begin
  BI[BD-1] := F(A+W*(P+BO*(BD-1)));
_9:
 end;
_10:
if ( (L1+L2)  < 1.5  ) and ( BQ  <= 0.25 ) 
 then goto _11;
BN := Abs(BI[0]+BI[4]-4.0*(BI[1]+BI[3])+6.0*BI[2]);
goto _13;
_11:
BF := (A+W*(P+BM))*RO+FI;
for BD:=1 to 5 do
 begin
  BJ[BD-1] := BI[BD-1]*Sin(BF);
  BK[BD-1] := BI[BD-1]*Cos(BF);
_12:
 end;
BF := BJ[0]+BJ[4]-4.0*(BJ[1]+BJ[3])+6.0*BJ[2];
BN := BK[0]+BK[4]-4.0*(BK[1]+BK[3])+6.0*BK[2];
BN := EMax1(L1*Abs(BF),L2*Abs(BN));
_13:
BN := BN*BM*0.42;
if ( H  <= HMIN ) 
 then goto _23;
if ( Abs(BN)-Z1 ) < 0
 then goto _18
 else if ( Abs(BN)-Z1 ) > 0
       then goto _14
       else goto _14;
_14:
H := H/2.0;
if ( H-SYS051*P ) < 0
 then goto _15
 else if ( H-SYS051*P ) > 0
       then goto _17
       else goto _15;
_15:
if ( P ) < 0
 then goto _16
 else if ( P ) > 0
       then goto _23
       else goto _16;
_16:
if ( H/4.0 ) < 0
 then goto _23
 else if ( H/4.0 ) > 0
       then goto _17
       else goto _23;
_17:
BI[4] := BI[2];
BI[2] := BI[1];
BM := H*0.5;
BQ := W*BM*RO;
BO := H*0.25;
BP := P+BO;
BI[1] := F(A+W*BP);
BI[3] := F(A+W*(BP+BM));
goto _10;
_18:
E1 := E1+Abs(BN);
BF := (A+W*(P+BM))*RO+FI;
BT := Sin(BF);
BU := Cos(BF);
BL := W*BM;
BV := RO*BL;
BW[3] := Sin(BV);
BW[4] := Cos(BV);
if ( BV-0.33 ) < 0
 then goto _19
 else if ( BV-0.33 ) > 0
       then goto _20
       else goto _19;
_19:
BX := BV*0.5;
BW[5] := Sin(BX);
BW[6] := Cos(BX);
BE[0] := 0.2666667;
BE[1] := 0.7111111*BW[6];
BE[2] := 0.1555556*BW[4];
BE[3] := 0.7111111*BW[5];
BE[4] := 0.1555556*BW[3];
goto _21;
_20:
BW[0] := 1.0/BV;
BW[1] := BW[0]*BW[0];
BW[2] := BW[1]*BW[1];
BE[0] := 4.0*BW[1]*(BW[0]*(48.0*BW[1]-19.0)*BW[3]+3.0*(1.0-
    16.0*BW[1])*BW[4]);
BE[1] := 32.0*BW[1]*(BW[0]*(5.0-12.0*BW[1])*BW[3]-(1.0-12.0*
    BW[1])*BW[4])/3.0;
BE[2] := BW[0]*((3.0-46.0*BW[1]+96.0*BW[2])*BW[3]+2.0*BW[0]*
    (7.0-48.0*BW[1])*BW[4])/3.0;
BE[3] := -16.0*BW[1]*((1.0-3.0*BW[1])*BW[3]+3.0*BW[0]*BW[4])/
    3.0;
BE[4] := BW[0]*(BW[0]*(11.0-24.0*BW[1])*BW[3]-3.0*(1.0-8.0*
    BW[1])*BW[4])/3.0;
_21:
BR := BE[0]*BI[2]+BE[1]*(BI[1]+BI[3])+BE[2]*(BI[0]+BI[4]);
BS := BE[3]*(BI[3]-BI[1])+BE[4]*(BI[4]-BI[0]);
J1 := J1+(BT*BR+BU*BS)*BM;
J2 := J2+(BU*BR-BT*BS)*BM;
P := P+H;
BH := 1.0-P;
if ( 1.0+BH/64.0-1.0 ) < 0
 then goto _22
 else if ( 1.0+BH/64.0-1.0 ) > 0
       then goto _24
       else goto _22;
_22:
BG := (Abs(F(B))+Abs(BI[4]))*BH/2.0;
if ( BG-Z2 ) < 0
 then goto _28
 else if ( BG-Z2 ) > 0
       then goto _23
       else goto _28;
_23:
XA := A+P*W;
J1 := J1*W;
J2 := J2*W;
INT1 := INT1+J1;
INT2 := INT2+J2;
_QSCOMX.elm1 := XA;
UTQS11(U,7);
goto _52;
_24:
BI[0] := BI[4];
if ( BN-Z1/32.0 ) < 0
 then goto _25
 else if ( BN-Z1/32.0 ) > 0
       then goto _26
       else goto _26;
_25:
H := 2.0*H;
_26:
if ( H-BH ) < 0
 then goto _8
 else if ( H-BH ) > 0
       then goto _27
       else goto _8;
_27:
H := BH;
goto _8;
_28:
J1 := J1*W;
J2 := J2*W;
E1 := E1*W;
if (  not ( (NI) ) ) 
 then case U of
       1: goto _33;
       2: goto _38;
      end;
BA := B;
B := A;
A := BA;
case U of
 1: goto _33;
 2: goto _38;
end;
_29:
IL := 1;
J := B;
L := A;
E2 := E;
E := 1000;
_30:
B := L+V*X;
if ( (B-J)*X ) < 0
 then goto _32
 else if ( (B-J)*X ) > 0
       then goto _31
       else goto _32;
_31:
B := J;
_32:
U := 1;
goto _5;
_33:
INT1 := J1;
INT2 := J2;
Q := EMax1(Abs(J1)*L1,Abs(J2)*L2);
E3 := E1;
_34:
Z := False;
_35:
R := Q;
A := B;
B := L+(B-L)*V;
if ( (B-J)*X ) < 0
 then goto _37
 else if ( (B-J)*X ) > 0
       then goto _36
       else goto _37;
_36:
B := J;
_37:
U := 2;
goto _5;
_38:
INT1 := INT1+J1;
INT2 := INT2+J2;
Q := EMax1(Abs(J1)*L1,Abs(J2)*L2);
E3 := E3+E1;
if ( Q  = 0  ) and ( R  = 0 ) 
 then goto _41;
if ( Q-0.999999*R ) < 0
 then goto _39
 else if ( Q-0.999999*R ) > 0
       then goto _34
       else goto _34;
_39:
S := Q/R;
S := Q*S/(1-S);
if ( S-E2 ) < 0
 then goto _40
 else if ( S-E2 ) > 0
       then goto _34
       else goto _34;
_40:
if (  not ( (Z) ) ) 
 then goto _47;
E3 := E3+S;
_41:
BB := EMax1(Abs(INT1)*L1,Abs(INT2)*L2);
BB := E2*(1+BB);
if ( E3-BB ) < 0
 then goto _48
 else if ( E3-BB ) > 0
       then goto _42
       else goto _48;
_42:
if ( IL-1 ) < 0
 then goto _43
 else if ( IL-1 ) > 0
       then goto _43
       else goto _44;
_43:
BC := EMax1((Abs(INT1-INT3)/(1+Abs(INT3))*L1),(Abs(INT2-
    INT4)/(1+Abs(INT4))*L2));
if ( BC-E2 ) < 0
 then goto _45
 else if ( BC-E2 ) > 0
       then goto _44
       else goto _45;
_44:
INT3 := INT1;
INT4 := INT2;
EPS := EPS/IntPower(2,5);
IL := 2;
goto _46;
_45:
E3 := BC;
goto _48;
_46:
A := L;
goto _30;
_47:
Z := True;
goto _35;
_48:
E := E2;
A := L;
B := J;
C := C+INT1;
G := G+INT2;
D := C;
I := G;
if ( Y ) 
 then goto _51;
if ( X+1 ) < 0
 then goto _49
 else if ( X+1 ) > 0
       then goto _50
       else goto _49;
_49:
T := E3;
M := B;
B := K;
X := 1;
goto _29;
_50:
E3 := E3+T;
A := M;
E := 2*E;
_51:
B := K;
XA := B;
INT1 := D;
INT2 := I;
if (  not ( (NIS) ) ) 
 then goto _52;
INT1 := -INT1;
INT2 := -INT2;
_52:
RINT1 := INT1;
RINT2 := INT2;
end;

end.
